#ifndef __CHANNEL__
#define __CHANNEL__

#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/thread/condition.hpp>
#include <iostream>

#include "typedefs.h"

class channel {
    // segnale start
    boost::mutex start_mtx_;
    boost::condition start_sem_;
    bool started_;
    // segnale stop
    boost::mutex stop_mtx_;
    boost::condition stop_sem_;
    bool stopped_;
    // segnale suspend
    boost::mutex susp_mtx_;
    boost::condition susp_sem_;
    bool susp_;
    // segnale wakeup
    boost::mutex wakeup_mtx_;
    boost::condition wakeup_sem_;
    bool wakeup_;
    // segnale fire alert
    boost::mutex falert_mtx_;
    boost::condition falert_sem_;
    bool falert_;
    // segnale recall
    boost::mutex recall_mtx_;
    boost::condition recall_sem_;
    bool recall_;
public:
    channel();
    void signal_start();       // start sent to monitors & pwr emgy
    void wait_start();
    void signal_stop();        // stop             "
    void wait_stop();
    bool stopped();
    void signal_susp();        // suspend sent to pwr emgy
    void wait_susp();
    bool suspended();
    void clearsuspended();
    void signal_wakeup();      // wakeup sent to pwr emgy
    void wait_wakeup();
    bool awoken();
    void clearawoken();
    void signal_falert();       // fire alert sent to ctrlr & pwr mon
    void wait_falert();
    bool falert();
    void signal_recall();      // recall sent to ctrlr & pwr mon
    void wait_recall();
    bool recall();
    void clearrecall();
};

#endif
