#include <iostream>
#include <time.h>
#include "controller.h"
#include "utility.h"
#include "channel.h"


void
cthrd_body_(Controller* const ctrl)
{
    ctrl->fch_->signal_start();    // start fire monitor
    logmsg(" Controller: fch_->signal_start() ");
    ctrl->pch_->signal_start();    // start power monitor
    logmsg(" Controller: pch_->signal_start()");

    for (;;) {              // loop until stopped by main
        if (ctrl->fch_->falert()) { // fire mon sent fire signal
            logmsg(" Controller: fire alert received");
            logmsg(" Controller: alerting pwr monitor");
            ctrl->pch_->signal_falert();    // alert power monitor
        }
        if (ctrl->fch_->recall()) { // fire monitor sent recall signal
            logmsg(" Controller: fire alert recalled");
            logmsg(" Controller: notifying pwr monitor");
            ctrl->pch_->signal_recall();    // wakeup power monitor
        }
        if (ctrl->sch_->stopped()) {   // main sent stop signal
             logmsg(" Controller: stopped by main");
             logmsg(" Controller: stopping monitors");
            ctrl->fch_->signal_stop();    // stop fire monitor
            ctrl->pch_->signal_stop();    // stop power monitor
            return;
        }
    }
}

Controller::
Controller(channel* fch, channel* pch, channel* sch)
    : fch_(fch), pch_(pch), sch_(sch)
{
    thrd_ = new boost::thread(&cthrd_body_, this);
}

void
Controller::
join()
{
    thrd_->join();
}

