#include <iostream>
#include "utility.h"
#include "firemonitor.h"

using namespace std;

void
fthrd_body_(FireMonitor* const fm)
{
    fm->ch_->wait_start();         // aspetta start da controller
    logmsg("    FireMonitor: started ");

    for (;;) {
        int temp = fm->tsens_->get_temperature();
        if (temp >= fm->tmax_) {     // fire detected
            fm->ch_->signal_falert();
            logmsg("    FireMonitor: fire_emergency() called");
            fm->emgcy_->fire_emergency();  // intervention lasts delta_f s
            fm->ch_->signal_recall();
            logmsg("    FireMonitor: fire extinguished");
        }
        if (fm->ch_->stopped()) {
            logmsg("    FireMonitor: stopped by controller");
            return;
        }
    }
}

FireMonitor::
FireMonitor(channel* ch, int tmax, TemperatureSensor* tsens)
            : ch_(ch), tmax_(tmax), tsens_(tsens)
{
    emgcy_ = new Fireemergency();
    thrd_ = new boost::thread(&fthrd_body_, this);
}

void
FireMonitor::
join()
{
    thrd_->join();
}

