#ifndef __FIREMONITOR__
#define __FIREMONITOR__

#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/thread/condition.hpp>
#include <iostream>

#include "typedefs.h"
#include "channel.h"
#include "fireemergency.h"
#include "temperaturesensor.h"

class FireMonitor;
void fthrd_body_(FireMonitor* const fm);   // fire monitor thread body

class FireMonitor {
    boost::thread* thrd_;
    channel* ch_;         // signal channel from controller
    int tmax_;            // threshold temperature (Celsius)
    TemperatureSensor* tsens_;
    Fireemergency* emgcy_;
friend
    void fthrd_body_(FireMonitor* const fm);   // fire monitor thread body
public:
    FireMonitor(channel* ch, int tmax, TemperatureSensor* tsens);
    void join();
};


#endif
