#include <boost/thread/thread.hpp>
#include <iostream>
#include <unistd.h>

#include "channel.h"
#include "temperaturesensor.h"
#include "powersensor.h"
#include "controller.h"
#include "firemonitor.h"
#include "powermonitor.h"
#include "params.h"

using namespace std;

int
main()
{
    channel fch;     // channel to fire monitor
    channel pch;     // channel to power monitor
    channel sch;     // channel to controller

    state pal;

    TemperatureSensor tsens;
    PowerSensor psens(&pal);
    Controller ctrl(&fch, &pch, &sch);
    FireMonitor fmon(&fch, TMAX, &tsens);
    PowerMonitor pmon(&pch, &psens);

    sleep(SIMTIME);
    sch.signal_stop();

    ctrl.join();
    fmon.join();
    pmon.join();

    return 0;
}
