#ifndef __PARAMS__
#define __PARAMS__

const int SIMTIME = 20;  // duration of simulation in seconds

const int TMAX = 1000;   // max temoerature in deg Celsius

// comment/uncomment according to desired scenario

/* scenario 1
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6
|--^-------+-----------^-+-----+--------> t
  t0f   t0p    f+delta_f t1p  t1p+delta_p
*/

// const int t_0f = 1000;   // start time of fire emgy (ms)
// const int delta_f = 10;   // duration of fire emgy intervention (s)

// const int t_0p = 5000;   // start time of pwr emgy (ms)
// const int delta_p = 3000;   // duration of pwr emgy intervention (ms)


/* scenario 2
 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6
|--+-------^-----^-------+--------------> t
  t_0p     |     |    end of pm
         t_0f t_0f+delta_f
*/

const int t_0f = 5000;   // start time of fire emgy (ms)
const int delta_f = 3;   // duration of fire emgy intervention (s)

const int t_0p = 1000;   // start time of pwr emgy (ms)
const int delta_p = 10000;   // duration of pwr emgy intervention (ms)

#endif
