#include <iostream>
#include <time.h>
#include "poweremergency.h"
#include "utility.h"
#include "params.h"
#include "state.h"

using namespace std;

void
ethrd_body_(Poweremergency* const pe)
{
    pe->ch_->wait_start();
    logmsg("        Poweremergency: Help! Call the electrician!");

    // last is used to remember when thread was suspended
    static std::chrono::time_point<std::chrono::steady_clock> last =
        std::chrono::steady_clock::now();

    static double total = 0;

    for (;;) {
        if (pe->ch_->suspended()) {
            logmsg("            pwr emergency suspended");
            const auto now = std::chrono::steady_clock::now();
            total +=
                std::chrono::duration<double, std::milli>(now - last).count();
            last = now;
            pe->ch_->wait_wakeup();
        }
        dormi(10);    // one simulated step
        const auto now = std::chrono::steady_clock::now();
        total +=
                std::chrono::duration<double, std::milli>(now - last).count();
            last = now;
        if (total >= delta_p) {   // finished
            pe->pa_->clearpal();
            logmsg("            Breaker replaced! ");
            return;
        }
    }
}

Poweremergency::
Poweremergency(channel* ch, state* pa)
             : ch_(ch), pa_(pa)
{
    thrd_ = new boost::thread(&ethrd_body_, this);
}

void
Poweremergency::
join()
{
    thrd_->join();
}

