#include <time.h>
#include <chrono>
#include <iostream>
#include "powermonitor.h"
#include "utility.h"
#include "state.h"

using namespace std;

void
pthrd_body_(PowerMonitor* const pwr)
{
    pwr->ch_->wait_start();
    logmsg("    PowerMonitor: started");

    for (;;) {
        if (pwr->ch_->falert()) {
            if (pwr->pa_->getemgy()) {  // pwr emgy already started?
                logmsg("    PowerMonitor: suspending power_emergency() (1)");
                pwr->ech_->signal_susp();  // fwd suspend to pwr emgy
            }
            pwr->pa_->setfal();         // remember fire alert
            continue;
        } else if (pwr->ch_->recall()) {
            if (pwr->pa_->getemgy()) {  // pwr emgy already started?
                logmsg("    PowerMonitor: waking up power_emergency() (1)");
                pwr->ech_->signal_wakeup();  // wake up pwr emgy
            }
            pwr->pa_->clearfal();         // clear fire alert
            if (pwr->pa_->getpal()) {
                logmsg("    PowerMonitor: starting power_emergency() (1)");
                pwr->ech_->signal_start();
                pwr->pa_->setemgy();         // emergency is running
            }
            continue;
        }
        logmsg("    PowerMonitor: calling getpal()");
        if (!pwr->pa_->getpal()) {
            if (!pwr->psens_->pwr_up()) {
                pwr->pa_->setpal();         // remember pwr alert
                if (!pwr->pa_->getfal()) {  // no fire emgy?
                    logmsg("    PowerMonitor: starting power_emergency() (2)");
                    pwr->ech_->signal_start();
                    pwr->pa_->setemgy();         // emergency is running
                }
            } else {
                logmsg("        PowerMonitor: power up");
                pwr->pa_->clearpal();         // clear pwr alert
            }
        }
        if (pwr->ch_->stopped()) {
            logmsg("        PowerMonitor: stopped by controller");
            break;
        }
        dormi(500);
    }
    pwr->emgcy_->join();
}

PowerMonitor::
PowerMonitor(channel* ch, PowerSensor* psens)
             : ch_(ch), psens_(psens)
{
    ech_ = new channel();
    pa_ = new state();
    emgcy_ = new Poweremergency(ech_, pa_);
    thrd_ = new boost::thread(&pthrd_body_, this);
}

void
PowerMonitor::
join()
{
    thrd_->join();
}

