#ifndef __POWERMONITOR__
#define __POWERMONITOR__

#include <boost/thread/thread.hpp>
#include <boost/thread/mutex.hpp>
#include <boost/thread/condition.hpp>
#include <iostream>

#include "typedefs.h"
#include "channel.h"
#include "poweremergency.h"
#include "powersensor.h"
#include "state.h"

class PowerMonitor;
void pthrd_body_(PowerMonitor* const pwr);   // power monitor thread body

class PowerMonitor {
    boost::thread* thrd_;
    channel* ch_;         // signal channel from controller
    channel* ech_;        // signal channel from pwr emergency
    PowerSensor* psens_;
    Poweremergency* emgcy_;
    state* pa_;           // pointer to global state vars
friend
    void pthrd_body_(PowerMonitor* const pwr);   // power monitor thread body
public:
    PowerMonitor(channel* ch, PowerSensor* psens);
    void join();
};


#endif
