#include <stdlib.h>
#include <time.h>
#include <chrono>
#include <iostream>
#include "utility.h"
#include "powersensor.h"
#include "params.h"

using namespace std;

static auto
    start = std::chrono::high_resolution_clock::now();    // initial time

bool
PowerSensor::
pwr_up()
{
    auto now = std::chrono::high_resolution_clock::now();    // curremt time
    double elapsed =
            std::chrono::duration<double, std::milli>(now - start).count();

    if (t_0p < elapsed && elapsed < t_0p + delta_p) { // detect pwr failure
        logmsg("          PowerSensor: POWER FAILURE");
        pem_->setpal();
        return false;
    } else {
        return true;
    }
}

