#include <stdlib.h>
#include <time.h>
#include <chrono>
#include <iostream>
#include "utility.h"
#include "temperaturesensor.h"
#include "params.h"

using namespace std;

static auto
    start = std::chrono::high_resolution_clock::now();    // initial time

TemperatureSensor::
TemperatureSensor()
{
}

int
TemperatureSensor::
get_temperature()
{
    auto now = std::chrono::high_resolution_clock::now();    // curremt time
    double elapsed =                                   // elapsed time in ms
            std::chrono::duration<double, std::milli>(now - start).count();

    if (t_0f < elapsed && elapsed < t_0f + delta_f) { // detect fire
        logmsg("      TemperatureSensor: fire alert");
        return 2*TMAX;
    } else {
        return TMAX/2;
    }
}
